%Expectation propagation example of lecture 7
%by Umut Orguner on March 02, 2011.
clear
close all


N=100;%Data length
x=zeros(1,N+1);%true state

sigmav=1;%process noise std
sigmae=0.5;%measurement noise std
K=20;%This is the K parameter in the two component mixture 0.9N(0,sigmae^2)+0.1N(0,(Ksigmae)^2)

%plot properties
linewidth=2;
markersize=15;
fontsize=15;

v=sigmav*randn(1,N);%genrate process noise
%generate states
for i=2:N+1,
    x(i)=x(i-1)+v(i-1);
end

%generate measurement noise
u=rand(1,N);
e=sigmae*randn(1,N);
e(u<=0.1)=K*e(u<=0.1);


y=x(2:N+1)+e;%generate measurements
maxy=max(y)+1;
miny=min(y)-1;


figure(1)
htrue=plot(0:N,x,'b','LineWidth',linewidth);
hold on
hmeas=plot(1:N,y,'r.','MarkerSize',markersize)

mu=zeros(1,N);%initial means of the factorial approximation
sigma2=4*ones(1,N);%initial variances of the factorial approximation

w=zeros(2,1);


[hl, hp] = boundedline(1:N,mu,4*sqrt(sigma2),'k','transparency', 0.3,'alpha');
set(hl,'linewidth',2) 
title(['EP: Recursion No: ',num2str(0)],'FontSize',fontsize);
legend([htrue,hmeas,hl],'True State','Measurements','EP')
ylim([miny maxy])
pause
for j=1:100,%total number of EP passes
    j
    %currently we make passes in the froward direction only. A better way
    %is to make passes one forward and one backward in which case one must
    %use i=[(1:N)],(N-1:-1:2)].
    for i=[(1:N)]%,(N-1:-1:2)],
        if i==1,
            rhobar2=sigma2(i+1)+sigmav^2;
            etabar=mu(i+1);
        elseif i==N,
            rhobar2=sigma2(i-1)+sigmav^2;
            etabar=mu(i-1);
        else
            rhobar2=1./(1/(sigma2(i-1)+sigmav^2)+1/(sigma2(i+1)+sigmav^2));
            etabar=rhobar2*(mu(i-1)/(sigma2(i-1)+sigmav^2)+mu(i+1)/(sigma2(i+1)+sigmav^2));
        end
        rho12=1/(1/rhobar2+1/(sigmae^2));
        rho22=1/(1/rhobar2+1/(K^2*sigmae^2));
        eta1=rho12*(etabar/rhobar2+y(i)/(sigmae^2));
        eta2=rho22*(etabar/rhobar2+y(i)/(K^2*sigmae^2));
        w(1)=0.9*normpdf(y(i),etabar,sqrt(rhobar2+sigmae^2));
        w(2)=0.1*normpdf(y(i),etabar,sqrt(rhobar2+K^2*sigmae^2));
        w=w/sum(w);
        mu(i)=w(1)*eta1+w(2)*eta2;%new mean
        sigma2(i)=w(1)*(rho12+(eta1-mu(i))^2)+w(2)*(rho22+(eta2-mu(i))^2);%new variance        
    end
    delete(hl);
    delete(hp);
    [hl, hp] = boundedline(1:N,mu,4*sqrt(sigma2),'k','transparency', 0.3,'alpha');
    set(hl,'linewidth',2)
    title(['EP: Recursion No: ',num2str(j)],'FontSize',fontsize);
    ylim([miny maxy])
    pause(0.5)
end
hold off

