function [xmodelout ymodelout]=doublemodel(xmodel,ymodel)
%forms an augmented model with state xi_k=[x_k; x_k-1]
%This is necessary for calculating E(x_kx_k-1) type of expectations with a
%Kalman smoother.


A=xmodel.A;
B=xmodel.B;
Q=xmodel.Q;
x0=xmodel.x0;
P0=xmodel.P0;

C=ymodel.C;
D=ymodel.D;
R=ymodel.R;


[ny,nx]=size(C);
[nw,~]=size(Q);
[ne,~]=size(R);


myinf=1e20;

Inx=eye(nx);
Znx=zeros(nx);
xmodelout.A=[A Znx; Inx Znx];
xmodelout.B=[B; zeros(nx,nw)];
xmodelout.Q=Q;
xmodelout.x0=[x0;zeros(nx)];
xmodelout.P0=blkdiag(P0,myinf*eye(nx));

ymodelout.C=[C,zeros(ny,nx)];
ymodelout.D=D;
ymodelout.R=R;



