function [x P x_ P_ logy]=kf(xmodel,ymodel,y,varargin)
%Kalman filter


A=xmodel.A;
B=xmodel.B;
Q=xmodel.Q;
x0=xmodel.x0;
P0=xmodel.P0;

C=ymodel.C;
D=ymodel.D;
R=ymodel.R;

[ny,N]=size(y);
[nx,~]=size(A);

if ~isempty(varargin),
    ymodelextra=varargin{1};
    yextra=varargin{2};
end



x=zeros(nx,N+1);
P=zeros(nx,nx,N+1);
x_=zeros(nx,N);
P_=zeros(nx,nx,N);

logy=0;

if isempty(varargin),
    x(:,1)=x0;
    P(:,:,1)=P0;
else
    if ~isempty(yextra{1})
        Cextra=ymodelextra.C{1};
        Dextra=ymodelextra.D{1};
        Rextra=ymodelextra.R{1};
        S=Cextra*P0*Cextra'+Rextra;
        K=P0*Cextra'/S;
        x(:,1)=x0+K*(yextra{1}-Cextra*x0);
        P(:,:,1)=P0-K*S*K';
        P(:,:,1)=0.5*(P(:,:,1)+P(:,:,1)');
    else
       x(:,1)=x0;
       P(:,:,1)=P0; 
    end
end

for i=1:N,
    x_(:,i)=A*x(:,i);
    P_(:,:,i)=A*P(:,:,i)*A'+B*Q*B';
    
    z=y(:,i);
    if isempty(varargin)
        S=C*P_(:,:,i)*C'+D*R*D';
        K=P_(:,:,i)*C'/S;
        ypred=C*x_(:,i);
    else
        Cextra=ymodelextra.C{i+1};
        Dextra=ymodelextra.D{i+1};
        Rextra=ymodelextra.R{i+1};         
        S=[C; Cextra]*P_(:,:,i)*[C; Cextra]'+blkdiag(D,Dextra)*blkdiag(R,Rextra)*blkdiag(D, Dextra)';
        K=P_(:,:,i)*[C; Cextra]'/S;
        ypred=[C; Cextra]*x_(:,i);                
    end        
    x(:,i+1)=x_(:,i)+K*(z-ypred);
    P(:,:,i+1)=P_(:,:,i)-K*S*K';    
    P(:,:,i+1)=0.5*(P(:,:,i+1)+P(:,:,i+1)');    
    logy=logy-0.5*ny*log(det(2*pi*S))-0.5*((z-ypred)'/S)*(z-ypred);
end










