function [x P logy]=ks(xmodel,ymodel,y, varargin)
%Kalman smoother

%forward pass
if isempty(varargin)
    [xf Pf xp Pp logy]=kf(xmodel,ymodel,y);
else
    [xf Pf xp Pp logy]=kf(xmodel,ymodel,y,varargin{:});
end

x=zeros(size(xf));
P=zeros(size(Pf));
[ny,N]=size(y);

A=xmodel.A;

%backward pass
x(:,N+1)=xf(:,N+1);
P(:,:,N+1)=Pf(:,:,N+1);

for i=N:-1:1,
    K=Pf(:,:,i)*A'/Pp(:,:,i);
    x(:,i)=xf(:,i)+K*(x(:,i+1)-xp(:,i));
    P(:,:,i)=Pf(:,:,i)+K*(P(:,:,i+1)-Pp(:,:,i))*K';
    P(:,:,i)=0.5*(P(:,:,i)+P(:,:,i)');
end

